/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   ADC
******************************************************************************/

#include "ADC.h"

/************************************************
;  *    @            : ADC_Init
;  *    @˵              : ADCʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void ADC_Init(void)
{
    ADCCR0 = 0x0C;        //0x0c_1.65V ,0x04 VDD,رADģ
    ADCCR1 = 0x03;        //¶ȴر,1x ,AIN3 
    ADCCR2 = 0X72;
    ADCCR3 = 0X00;        //ǣλת12bit
    ADCCR4 = 0X00;
    ADCCR0 |= 1;          //ʹADC
}
/****  ͨѡ  ***/
void ADC_ADCHS(uint8_t CH)
{
    ADCCR1 &=~ 0x0f;
    ADCCR1 |=  CH;
}
/****  ADɼ  ***/
uint16_t ADC_Get_FlagStatus(void)
{
    uint16_t temp;
    SET_ADEOC();          //ת
    // ADC_FLAG = 1;
    while(ADCCR0 & 0x02);
    temp = 0;
    temp = ADRH<<8;
    temp += ADRL;
    return temp;
}
/************************************************
;  *    @            : ADC_Get_Value
;  *    @˵              : ADɼ
;  *    @          : CH
;  *    @ز          :
;  ***********************************************/
uint16_t ADC_Get_Value(uint8_t CH)
{
    uint8_t channel = 0;
    uint32_t tmpBuff = 0;
    uint16_t AdcMAX = 0;
    uint16_t AdcMIN = 0xffff;
    uint16_t temp_value = 0;
    ADC_ADCHS(CH);                  //ͨѡ
    for (channel = 0; channel < 20; channel++)
    {
        temp_value = ADC_Get_FlagStatus();
        if (channel < 2)
            continue;                 //ǰβֵ
        if (temp_value > AdcMAX)
            AdcMAX = temp_value;      //
        if (temp_value < AdcMIN)
            AdcMIN = temp_value;      //С
        tmpBuff += temp_value;
    }
    tmpBuff -= AdcMAX;              //ȥһ
    tmpBuff -= AdcMIN;              //ȥһС
    temp_value = (tmpBuff >> 4);    //16,ȡƽֵ
    return temp_value;
}
