/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2022.05.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                    ADC
;  *              ADɼAIN3 (P27)AIN4 (P26)
;  *              ɼֵͨP04(TX)˿ôڴӡ  ڲʣ9600
******************************************************************************/

#include "user.h"

/************************************************
;  *    @            : delay
;  *    @˵              : ʱʾʹãʵʱ
;  *    @          : Num
;  *    @ز          :
;  ***********************************************/
 void delay(uint16_t Num)
{
    for (; Num > 0; Num--)
    {
        NOP10();
    }
}

/************************************************
;  *    @            : ADC_ZERO
;  *    @˵              : ADCƫУ׼
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void ADC_ZERO(void)
{
    ADASCR0 |= DEF_SET_BIT7;
    while(ADASCR0 & 0x80);
}

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main()
{
    uint16_t ADC_value_buff[2];
    DISABLE_GIE();                  //رж
    GPIO_Init();
    ADC_Init();
    ADC_ZERO();
    UART1_Init();
    printf("Sinomcu\r\n");
    ENABLE_GIE();                   //ж
    while(1)
    {
        ADC_value_buff[0] = ADC_Get_Value(CH3);
        ADC_value_buff[1] = ADC_Get_Value(CH4);
        printf("ADCH0:%hu ", ADC_value_buff[0]);
        printf(" ADCH1:%hu\r\n ", ADC_value_buff[1]);
        delay(50000);
        delay(50000);
        delay(50000);
        delay(50000);
        delay(50000);
        delay(50000);
    }
}
