/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2023.02.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#include "TIMER.h"

__O Flag Flag1;

uint16_t g_timer1s_count;
/************************************************
;  *    @            : Timer0_Init
;  *    @˵              : ʱʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Timer0_Init(void)
{
    TMOD = 0x02;        //ʽ2
    TCON = 0x00;
    TCON1 = 0x02;       //FSYS/8
    TR0 = 0;
    TL0 = 0x44;         //1ms
    TH0 = 0x44;
    IP = 0x02;
    IPH = 0x02;         //жϵȼ3()
    T0IE = 1;
    EA = 1;
    TR0 = 1;
}

void Timer2_Init(void)
{
    T2CON = 0x00;
    T2CON1 |= 0x01;     //T2ģ,ʽ0
    T2MOD = 0x90;       //Զ, Fsys/4
    TR2 = 0;
    TL2 = 0x23;
    TH2 = 0xFA;
    RCAPL2 =0x88;
    RCAPH2 =0xFE;
    IE1 |= 0x01;        //T2ж
    EA = 1;
    TR2 = 1;
}
void Timer0_ISR(void) interrupt T0_IRQn
{
    g_timer1s_count++;  //1ms
    if(g_timer1s_count == TIME_1S)
    {
        g_timer1s_count = 0;
        TIMER1S_FLAG = 1;
    }
}

void Timer2_ISR(void) interrupt T2_IRQn
{
    if(TF2 == 1)
    {
        TF2 = 0;
        LED1 = !LED1;
    }
}