/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2023.02.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                        Soft_Reset
;  *                   мλ־
;  *                   ϵʼ״̬LED1 T2 1msжȡ
;  *                   1SλT2жʱΪ2ms.
******************************************************************************/
#include "user.h"

uint8_t g_reset_num = 0xA5;

void Soft_Reset(void)
{
    DISABLE_GIE();
    SET_SWRST();
    SET_SWRST();
    ENABLE_GIE();
}

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    DISABLE_GIE();
    OSCSS &= 0x80;
    OSCSS |= 0x40;           //16ƵFsys=48/2/16
    GPIO_Init();
    Timer0_Init();
    Timer2_Init();
    ENABLE_GIE();
    if((RSTFLAG & DEF_SET_BIT3) == DEF_SET_BIT3)
    {
        RSTFLAG &=~ DEF_SET_BIT3;
        TR2 = 0;
        RCAPL2 =0x11;
        RCAPH2 =0xFD;         //2ms
        TR2 = 1;
        g_reset_num = 0x5A;
    }
    while(1)
    {
       if((TIMER1S_FLAG)&&(g_reset_num == 0xA5))
       {
          TIMER1S_FLAG = 0;
          Soft_Reset();
       }
    }
}
