/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                       9600
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @            : UART0_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART0_Init(void)
{
    PCON |= DEF_SET_BIT4;         //ʹUART0
    SCON &= 0x3f;
    SCON |= 0x50;                 //ʽ1  
  
    TMOD &= 0xCF;
    TMOD |= DEF_SET_BIT5;         //ڲʱ  ʽ2
    TL1 = T1_Cnt;
    TH1 = T1_Cnt;
    TR1 = 1;                      //T1
    
    IE |= DEF_SET_BIT4;           //UART0ж
}

/************************************************
;  *    @     : putchar   (ռ1kROM)
;  *    @˵       : printfضputchar
;  *    @    :
;  *    @ز    :
;  ***********************************************/
char putchar(char tx_data)
{
    SBUF = tx_data;               //дݵUARTݼĴ
    while (!(SCON & 0x02));       //ȴǰݷ
    SCON &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART0_ISR(void) interrupt UART0_IRQn
{
    if (((SCON & 0x01) == 1))
    {
        SCON &= ~DEF_SET_BIT0;
    }
  
}
