/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2023.02.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                      NSS-P06D ;SCK-P07D
;  *                      MISO-P26D ; MOSI-P27D
******************************************************************************/

#include "SPI.h"

/************************************************
;  *    @     : SPI1_ReadWriteByte
;  *    @˵       : SPIݷ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
uint8_t SPI1_ReadWriteByte(uint8_t TxData)
{
    SPDAT = TxData;
    while (!(SPSTA & 0x40)); //ݴж
    SPSTA &= ~0x40;
    return SPDAT;
}

/************************************************
;  *    @     : SPI_Init
;  *    @˵       : SPIʼ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
void SPI_Init(void)
{
#if(SPI_Master_Slave==0)     //
    SPI_CS = 1;              //ʹƬѡ
    SPCON &= 0x00;
    SPCON |= 0x48;
    SPCON |= DEF_SET_BIT5;   //CPHA = 1
    SPCON |= DEF_SET_BIT4;   //CPOL = 1
    SPCON |= DEF_SET_BIT0;   //Fspi = Fsys/4 = 3MHz
    SPSTA = 0x80;
#else                        //ӻ
    SPCON &= 0x00;
    SPCON |= DEF_SET_BIT5;   //CPHA = 1
    SPCON |= DEF_SET_BIT4;   //CPOL = 1
    SPCON |= DEF_SET_BIT0;   //Fspi = Fsys/4 = 3MHz
    SPSTA = 0x80;
#endif
}

void SPI_ISR(void) interrupt SPI_IRQn
{
    SPSTA &= ~DEF_SET_BIT6;
}
