/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   UART ʣ9600
;  *                   UART TX -- P04D
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @            : UART1_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART1_Init(void)
{
    PCON  |= DEF_SET_BIT7;     //UART1ģ
  
    SCON_1|= DEF_SET_BIT6;     //ʽ1
    SCON_1|= DEF_SET_BIT4;     //
  
    TMOD  |= DEF_SET_BIT5;
    TMOD  &= DEF_CLR_BIT4;     //ڲʱ ʽ2
  
    BRGCR |= DEF_SET_BIT7;     //ʹܲʷ 
    BRGH = band_CntH;
    BRGL = band_CntL;
  
    IE1 |= DEF_SET_BIT3;       //UART1ж
}

/************************************************
;  *    @            : putchar
;  *    @˵              : ڷ
;  *    @          : tx_data
;  *    @ز          :
;  ***********************************************/
char putchar(char tx_data)
{
    SBUF_1 = tx_data;             //дݵUARTݼĴ
    while (!(SCON_1 & 0x02));     //ȴǰݷ
    SCON_1 &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART1_ISR(void) interrupt UART1_IRQn
{
    if((SCON_1 & 0x01)== 1)
    {
        SCON_1 &= DEF_CLR_BIT0;
    }
}
