/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                T3ʱʽ0 ϵͳƵʱ1ms
;  *                       ʽ1 ϵͳƵ32Kʱ2ms
******************************************************************************/

#include "TIMER.h"

/************************************************
;  *    @            : Timer3_Init
;  *    @˵              : T3ʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Timer3_Init(void)
{
    //Fsys= 48/2/4= 6MHz
#if(TIMER_MODE == 0)    //T3 ʽ0  ϵͳʱ(ͬʱ)ģʽ
    T3CR |= DEF_SET_BIT0;    //Fsys/4
    //ǶдTL3/TH3ֵֹͣT3TR3=0
    T3CR &=~DEF_SET_BIT7;
    TL3 = 0X23;
    TH3 = 0XFA;              //ʱ1ms
    T3CR |= DEF_SET_BIT7;

    T3CR |= DEF_SET_BIT3;    //T3ģ
    IE1  |= DEF_SET_BIT1;    //ʹж
#endif
    //Fsys = 32KHz
#if(TIMER_MODE == 1)    //T3 ʽ1  Ƶʱ(첽ʱ)ģʽ
    T3CR |= DEF_SET_BIT6;    //Ƶʱ
    T3CR |= DEF_SET_BIT0;    //Fsys/4
    //ǶдTL3/TH3ֵֹͣT3TR3=0
    T3CR &=~ DEF_SET_BIT7;   //رT3
    TL3 = 0XEF;
    TH3 = 0XFF;              //ʱ2ms
    T3CR |= DEF_SET_BIT7;    //T3

    T3CR |= DEF_SET_BIT3;    //T3ģ
    IE1 |= DEF_SET_BIT1;     //ʹж
#endif
}

void Timer3_ISR(void) interrupt T3_IRQn
{
#if(TIMER_MODE == 0)
    LED1 =! LED1;
#endif

#if(TIMER_MODE == 1)
    LED2 =! LED2;
#endif
}
