/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   UART  ʣ9600
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @            : UART0_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART0_Init(void)
{
    PCON |= DEF_SET_BIT4;      //ʹUART0
    SCON &= 0x3f;
    SCON |= 0x50;              //ʽ1  
    TMOD &= 0xCF;
    TMOD |= DEF_SET_BIT5;      //ڲʱ  ʽ2
    TL1 = T1_Cnt;
    TH1 = T1_Cnt;
    TR1 = 1;                   //T1
    IE |= DEF_SET_BIT4;        //UART0ж  
}

/************************************************
;  *    @            : putchar
;  *    @˵              : UARTݷ
;  *    @          : tx_data
;  *    @ز          :
;  ***********************************************/
char putchar(char tx_data)
{
    SBUF = tx_data;            //дݵUARTݼĴ
    while (!(SCON & 0x02));    //ȴǰݷ
    SCON &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART0_ISR(void) interrupt UART0_IRQn
{
    if(((SCON & DEF_SET_BIT0) == DEF_SET_BIT0))
    {
        SCON &= ~DEF_SET_BIT0;
        if(UART_RX_END == 0)
        {
            if(UART_RX_STA == 0)
            {
                if(SBUF == 0x0d)     //յ0x0d
                {
                    UART_RX_STA = 1;
                }
                else
                {
                    UART_rx_buff[UART_rx_len] = SBUF;
                    UART_rx_len++;
                }
            }
            else
            {
                if(SBUF == 0x0a)     //յ0x0d
                {
                    UART_RX_END = 1;
                }
                else
                {
                    UART_RX_STA = 0;
                    UART_rx_len = 0;
                }
            }
        }
    }
}
