/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *              ʣ9600
;  *                TX    P04
;  *                RX    P05
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @            : UART1_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART1_Init(void)
{
    PCON  |= DEF_SET_BIT7;        //UART1ģ
  
    SCON_1|= DEF_SET_BIT6;        //ʽ1
    SCON_1|= DEF_SET_BIT4;        //
  
    TMOD  |= DEF_SET_BIT5;
    TMOD  &= DEF_CLR_BIT4;        //ڲʱ ʽ2
  
    BRGCR |= DEF_SET_BIT7;        //ʹܲʷ 
    BRGH = band_CntH;
    BRGL = band_CntL;
  
    IE1 |= DEF_SET_BIT3;          //UART1ж
}

char putchar(char tx_data)
{
    SBUF_1 = tx_data;             //дݵUARTݼĴ
    while (!(SCON_1 & 0x02));     //ȴǰݷ
    SCON_1 &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART1_ISR(void) interrupt UART1_IRQn
{
    if(((SCON_1 & DEF_SET_BIT0) == DEF_SET_BIT0))
    {
        SCON_1 &= ~DEF_SET_BIT0;
        if(UART_RX_END == 0)
        {
            if(UART_RX_STA == 0)
            {
                if(SBUF_1 == 0x0d)     //յ0x0d
                {
                    UART_RX_STA = 1;
                }
                else
                {
                    UART_rx_buff[UART_rx_len] =SBUF_1;
                    UART_rx_len++;
                }
            }
            else
            {
                if(SBUF_1 == 0x0a)     //յ0x0d
                {
                    UART_RX_END = 1;
                }
                else
                {
                    UART_RX_STA = 0;
                    UART_rx_len = 0;
                }
            }
        }
    }
}
