/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2023.02.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#include "ADC.h"

__O Flag Flag1;

/************************************************
;  *    @            : ADC_Get_Value
;  *    @˵              : ȡADCֵ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
uint16_t ADC_Get_Value(void)
{
    uint16_t temp;
    temp = 0;
    temp = ADRH<<8;
    temp += ADRL;
    return temp;
}

/************************************************
;  *    @            : ADC_Init
;  *    @˵              : ADCʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void ADC_Init(void)
{
    ADCCR0 = 0x0C;      //V1.65
    ADCCR1 = 0x04;      //¶ȴر,1x ,AIN4
    ADCCR2 = 0X72;
    ADCCR3 = 0X6C;
    ADCCR4 = 0X03;      //timer2ADC
    ADCCR0 |= 1;        //ʹADC
    IE|= 0x40;          //ʹADCж
    IP |=0X40;
    IPH |=0X40;
}

void ADC_ISR(void) interrupt ADC_IRQn
{
    ADCCR0 &=~ 0x10; 
    FLAG_ADC = 1;
    LED2 = !LED2;
}
