/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2023.02.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                        ADC_Timer_trigger
;  *                        TIMER2 10msADCɼ
;  *                        ڴӡADCתѹֵ
;  *                        ADCͨAN4(P26)
;  *                        UART:   TX (P04)
;  *                        ADC һ16תۼȡƽ
******************************************************************************/
#include "user.h"

uint16_t ADC_temp;
uint16_t Voltage_mV;
/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/

void main(void)
{
    DISABLE_GIE();
    GPIO_Init();
    Timer2_Init();
    ADC_Init();
    UART1_Init();
    printf("\r\n--Inf:sinomcu.com");
    printf("\r\n--Inf:ADC_Timer_trigger");
    ENABLE_GIE();
    while(1)
    {
        if(FLAG_ADC)
        {
            FLAG_ADC = 0;
            ADC_temp = ADC_Get_Value();
            ADC_temp >>= 1;       //ϵͳѽ3λ8,ûٴγ2.
            Voltage_mV =(uint16_t)((float)(ADC_temp)*(VREF_mV)/FULL_SCALE/ADCGainvalue);
            printf("\r\n--Inf:P26(AN4) ADC value is 0x%X,Voltage %dmV.", ADC_temp, Voltage_mV);
        }
    }
}
