/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2022.05.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *              PWM1ģʽ & ģʽ
;  *              Fsys = 6MHz
******************************************************************************/

#include "PWM.h"

/************************************************
;  *    @            : PWM1_Init
;  *    @˵              : PWM1ʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void PWM1_Init(void)
{
    PWM1RLEN = 0x55;              //Ᵽ޸ PWM ܱĴ
    PWM1OE = 0x3f;                // 6  I/O Ϊ PWM 
    PWM1CR0 = 0x00;               //PWM ʱѡϵͳʱӣñضģʽԤƵΪ 1ƵΪ 1
    PWM1CR1 = 0x00;               //PWM ģʽPWM1x  PWM1xN λx=A,B,C

    PWM1PL = 0x70;                //Fsys=6MHz ,PWM Ϊ 6000 Fsysclk,1ms
    PWM1PH = 0x17;
    PWM1FBCR = 0x3A;              //ѡɲź1͵ƽЧ˲ʱ䳣4usģʽ
  
#if (PWM1_Mode == 1)              //ģʽ
    PWM1CR1 = 0x00;               //ģʽ
    PWM1CR2 = 0x00;
    PWM1DT0L = 0x02;              // ǰʱΪ 2 Fsys clk
    PWM1DT1L = 0x02;              // ʱΪ 2 Fsys clk

    PWM1ADL = 0x60;               //PWM1A ռձΪ 40%
    PWM1ADH = 0x09;
    PWM1BDL = 0xb8;               //PWM1B ռձΪ 50%
    PWM1BDH = 0x0b;
    PWM1CDL = 0x10;               //PWM1C ռձΪ 60%
    PWM1CDH = 0x0e;
#endif
  
#if (PWM1_Mode == 2)              //ģʽ
    PWM1CR1  = 0xb8;              //ģʽ ռձڼߵƽ
    PWM1ADL  = 0x58;              //PWM1A ռձΪ 10%
    PWM1ADH  = 0x02;
    PWM1ANDL = 0xb0;              //PWM1AN ռձΪ 20%
    PWM1ANDH = 0x04;
    PWM1BDL  = 0x60;              //PWM1B ռձΪ 40%
    PWM1BDH  = 0x09;
    PWM1BNDL = 0x10;              //PWM1BN ռձΪ 60%
    PWM1BNDH = 0x0e;
    PWM1CDL  = 0xc0;              //PWM1C ռձΪ 80%
    PWM1CDH  = 0x12;
    PWM1CNDL = 0x18;              //PWM1CN ռձΪ 90%
    PWM1CNDH = 0x15;
#endif

    PWM1IE |= DEF_SET_BIT6;       //PWM ƥж
    PWM1OE |= DEF_SET_BIT7;       // PWM ʱ
    IE1 = DEF_SET_BIT5 | DEF_SET_BIT2 ;          //ʹɲPWM1ж
    PWM1RLEN = 0xAA;                             //أ PWM ļĴֵ루ڣռձȣȣ  
}

void PWM1_ISR(void) interrupt PWM1_IRQn
{
    PWM1IF &=~ DEF_SET_BIT6;                     //жϱ־
    LED1=!LED1;
}

void PWM1FB_ISR(void) interrupt PWM1FB_IRQn      //ɲж
{
    LED2 =! LED2;
}
