/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                      SPI:NSS-P06D ;SCK-P07D
;  *                          MISO-P26D ; MOSI-P27D
******************************************************************************/

#include "SPI.h"

/************************************************
;  *    @     : SPI_Init
;  *    @˵       : SPIʼ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
void SPI_Init(void)
{
    SPCON = 0x79;                 //MSBʼ䣬ڶزɼ״̬ߵƽرSSţ4Ƶ
    IE |= DEF_CLR_BIT5;           //رSPIж
    SPSTA |= DEF_SET_BIT7;        //ʹSPI
}

/************************************************
;  *    @     : SPI1_ReadWriteByte
;  *    @˵       : SPIݷ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
uint8_t SPI1_ReadWriteByte(uint8_t TxData)
{
    SPDAT = TxData;               //
    while (!(SPSTA & 0x40));      //
    SPSTA &= DEF_CLR_BIT6;
    return SPDAT;
} 

void SPI_ISR(void) interrupt SPI_IRQn
{
    SPSTA &= ~DEF_SET_BIT6;
}
