/******************************************************************************
;  *       @ͺ                  : MC51F7424
;  *       @              : 2022.05.09
;  *       @˾/             : ΢-FAE
;  *       @΢            : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *           SPI_Master_Slave
;  *      SPIӻ,ӻشյ
;  *      Աȷյݣ
;  *      һʱLED1(P02),LED2(P03)λ
;  *      MISO-P26D;MOSI-P27D
;  *      NSS-P06D ; SCK-P07D
;  *      CPHA = 1;CPOL = 1;
;  *      ̰ӻûSPI.hļ޸"SPI_Master_Slave"궨ѡӦ̡
******************************************************************************/

#include "user.h"

__O Flag flag1;

#if(SPI_Master_Slave == 0)
uint8_t master_buff[10] = {1,2,3,4,5,6,7,8,9,10};
uint8_t master_ck_buff[11];
uint8_t master_count = 0;
#else
uint8_t count1=0;
#endif

/************************************************
;  *    @            : delay
;  *    @˵              : ȷʱ Fsys = 48/2/2 = 12MHz
;  *    @          : Num
;  *    @ز          :
;  ***********************************************/
void delay(uint16_t Num)
{
    for (; Num > 0; Num--)
    {
        NOP1();
    }
}

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    DISABLE_GIE();           //رж
    OSCSS = 0x90;            //2Ƶ,Fsys=48/2/2
    GPIO_Init();
    SPI_Init();
    ENABLE_GIE();            //ж
    while (1)
    {
        #if(SPI_Master_Slave == 0)

        SPI_CS = 0;          //ʹƬѡ

        for(master_count = 0; master_count < 10; master_count++)
        {
            master_ck_buff[master_count]=SPI1_ReadWriteByte(master_buff[master_count]);
        }
        master_ck_buff[master_count]=SPI1_ReadWriteByte(0x00);       //ش֡β

        SPI_CS = 1;          //ʹƬѡ

        for(master_count = 0; master_count < 10; master_count++)
        {
            if(master_buff[master_count] != master_ck_buff[master_count+1])
            {
                LED1 = 1;LED2 = 0;
                break;
            }
            else 
            {
                LED1 = 0;LED2 = 1;
            }
        }
        #else
        while (!(SPSTA & 0x40));
        SPSTA &= ~0x40;
        count1 = SPDAT;      //ֱӲĴ
        NOP1();
        SPDAT = count1;
        #endif
    }
}
