/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                 T0ʽ0,1,2,3
******************************************************************************/

#include "TIMER.h"

/************************************************
;  *    @            : Timer0_Init
;  *    @˵              : ʱʼʱʽ0~3
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Timer0_Init(void)
{
#if(TIMER_MODE == 0)    //T0 ʽ0  13λ/ʱ
    TMOD = 0x00;        //ʽ0
    TCON = 0x00;
    TCON1 = 0x02;       //48/2/1/8
    TR0 = 0;
    TL0 = 0x10;         //2ms 8192 - 6000 = 2192
    TH0 = 0x44;
    
    IP = 0x02;
    IPH = 0x02;         //жϵȼ3()
    T0IE = 1;           //ʹT0ж
    EA = 1;             //ʹж
    TR0 = 1;
#endif

#if(TIMER_MODE == 1)    //T0 ʽ1  16λ/ʱ
    TMOD = 0x01;        //ʽ1
    TCON = 0x00;
    TCON1 = 0x02;
    TR0 = 0;
    TL0 = 0x47;         //1ms 
    TH0 = 0xf4;
    
    IP = 0x02;
    IPH = 0x02;         //жϵȼ3()
    T0IE = 1;
    EA = 1;
    TR0 = 1;
#endif

#if(TIMER_MODE == 2)    //T0 ʽ2  8λԶؼ/ʱ
    TMOD = 0x02;        //ʽ2
    TCON = 0x00;
    TCON1 = 0x03;       //FSYS/16
    TR0 = 0;
    TL0 = 0x6A;          //100us
    TH0 = 0x6A;
  
    IP = 0x02;
    IPH = 0x02;         //жϵȼ3()
    T0IE = 1;
    EA = 1;
    TR0 = 1;
#endif

#if(TIMER_MODE == 3)    //T0 ʽ3  8λ/ʱ(ֻT0)
    TMOD = 0x03;        //ʽ3
    TCON = 0x00;
    TCON1 = 0x03;       //FSYS/16
    TR0 = 0;
    TL0 = 0x6A;         //100us
    TH0 = 0x1E;         //150us
    
    IP = 0x02;
    IPH = 0x02;         //жϵȼ3()
    T0IE = 1;
    T1IE = 1;
    EA = 1;
    TR0 = 1;
    TR1 = 1;
#endif
}

void Timer0_ISR(void) interrupt T0_IRQn
{
#if(TIMER_MODE == 0)
    TR0 = 0;
    TL0 = 0x10;
    TH0 = 0x44;
    LED1 = !LED1;
    TR0 = 1;
#endif

#if(TIMER_MODE == 1)
    TR0 = 0;
    TL0 = 0x47;
    TH0 = 0xf4;
    LED1 = !LED1;
    TR0 = 1;
#endif

#if(TIMER_MODE == 2)
    LED1 = !LED1;
#endif

#if(TIMER_MODE == 3)
    TR0 = 0;
    TL0 = 0x6A;         //100us
    TR0 = 1;
    LED1 = !LED1;
#endif
}

void Timer1_ISR(void) interrupt T1_IRQn
{
#if (TIMER_MODE == 3)  
    TR1 = 0;
    TH0 = 0x1E;         //150us
    TR1 = 1;
    LED2 = !LED2;
#endif
}
